import ao, mad

class Decoder:

  def __init__(self, filename, driver="oss"):
    self.filename = filename
    self.madfile = mad.MadFile(self.filename)
    self.rate = self.getSampleRate()

    self.driver = driver
    self.dsp = None

  def initAudio(self):
    self.dsp = ao.AudioDevice(self.driver, bits=16, rate=self.rate)

  def getBuf(self):
    self.buf = self.madfile.read()
    return self.buf == None and 0 or 1
  
  def outputFrame(self):
    self.dsp.play(self.buf, len(self.buf))

  def seek(self, secs):
    return self.madfile.seek_time(secs*1000)
  
  def getBitrate(self):
    return self.madfile.bitrate()/1000

  def getLen(self):
    return self.madfile.total_time()/1000

  def getSampleRate(self):
    return self.madfile.samplerate()
